<?php

namespace App\Http\Controllers\Owner\GroupPassengerMedia;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Http\Helpers\ResponseBuilder;
use App\Http\History\HistoryData;
use App\Http\History\HistoryTables;
use App\Modules\GroupPassengerMedia\Application\Delete\DeleteGroupPassengerMediaQuery;
use App\Modules\GroupPassengerMedia\Application\Delete\DeleteGroupPassengerMediaResponse;
use App\Modules\Shared\Domain\Bus\Query\QueryBus;
use App\Modules\Shared\Domain\Transaction;

class GroupPassengerMediaDeleteController extends Controller
{
    private $domain = "GroupPassengerMedia";
    private HistoryData $history;

    public function __construct(
        private QueryBus $queryBus,
        private Transaction $transaction
    ) {
        $this->history = new HistoryData(HistoryTables::GROUP_PASSENGER_MEDIA);
    }

    public function __invoke(Request $request, $Id)
    {
        $this->history->obtainOld($Id);
        $this->transaction->begin();
        /** @var DeleteGroupPassengerMediaResponse $response */
        $response = $this->queryBus->ask(new DeleteGroupPassengerMediaQuery($Id));

        $this->transaction->commit();
        $this->history->deleteBasic($Id, $request);

        return ResponseBuilder::Response([
            "Response_Status"           => 200,
            "Response_Code"             => 200,
            "Response_Data"             => [],
            "Response_Domain"           => $this->domain,
            "Response_Message"          => 'Moneda de Facturación eliminada con éxito',
            "Response_Error_Message"    => '',
            "Response_Error_Reason"     => '',
        ]);
    }
}
